%% @author jstypka <jasieek@student.agh.edu.pl>
%% @version 1.0
%% @doc This module contains common helpers for different models of computation

-module(mas_misc_util_mini).
-export([generate_population/2]).

-include ("mas.hrl").

-type agent() :: mas:agent().
-type sim_params() :: mas:sim_params().
-type agent_behaviour() :: mas:agent_behaviour().

%% @doc Generates a population of agents with random solutions.
-spec generate_population(sim_params(), config()) -> [agent()].
generate_population(SP, Cf) ->
    Env = Cf#config.agent_env,
    [Env:initial_agent(SP) || _ <- lists:seq(1, Cf#config.population_size)].



